#pragma warning(disable : 4996)

#include <map>
#include <string>
#include <vector>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <ios>
#include <streambuf>
#include <sstream>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <limits.h>
#include <shlobj.h>
#include <tchar.h>

//boost libraries
#include <boost/foreach.hpp>


// ObjectModule̓eXmlŐꍇ͂̍sLɂ
//#define OBJECT_MODULE_IS_NOT_BINARY


#ifdef OBJECT_MODULE_IS_NOT_BINARY
#include <boost/archive/xml_oarchive.hpp>
#include <boost/archive/xml_iarchive.hpp>
#else
#include <boost/archive/binary_oarchive.hpp>
#include <boost/archive/binary_iarchive.hpp>
#endif
#include <boost/serialization/string.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/level.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/map.hpp>
#include <boost/serialization/version.hpp>
#include <boost/serialization/is_abstract.hpp>
#include <boost/serialization/serialization.hpp>
#include <boost/serialization/nvp.hpp>
#include <boost/serialization/export.hpp>

#define foreach(v, c) for each (v in c)

#include <jenga/include/jenga.h>
#include <abdev/ab_common/include/ab_common.h>


void ObjectModule::StaticLink( ObjectModule &objectModule, bool isSll )
{
	const std::vector<int> relationTable = this->GetRelationTable( objectModule.relationalObjectModuleNames );

	long dataSectionBaseOffset = dataTable.GetSize();

	// ^
	meta.StaticLink( objectModule.meta, dataSectionBaseOffset, relationTable );

	if( !isSll )
	{
		// O[o lCeBuR[h
		objectModule.globalNativeCode.ResetDataSectionBaseOffset( dataSectionBaseOffset );
		objectModule.globalNativeCode.ResetRelationalObjectModuleIndex( relationTable );
		globalNativeCode.PutEx( objectModule.globalNativeCode );

		// f[^e[u
		objectModule.dataTable.ResetDataSectionBaseOffset( dataSectionBaseOffset );
		dataTable.Add( objectModule.dataTable );
	}

	// TODO: basbufȂȂ
	extern char *basbuf;
	basbuf = this->source.GetBuffer();
}

void ObjectModule::Resolve( ResolveErrors &resolveErrors )
{
	this->meta.Resolve( *this, resolveErrors );

	// O[olCeBuR[hiXPW[j
	this->globalNativeCode.Resolve( *this, resolveErrors );

	// f[^e[uiXPW[j
	this->dataTable.Resolve( *this, resolveErrors );
}

const std::vector<int> ObjectModule::GetRelationTable( const Jenga::Common::Strings &oldRelationalObjectModuleNames )
{
	// vf = ÂCfbNXAl = VCfbNX
	std::vector<int> relationTable;

	// [Ve[u\z
	foreach( const std::string &oldRelationalObjectModuleName, oldRelationalObjectModuleNames )
	{
		bool isMatch = false;
		for( int i=0; i<static_cast<int>(this->relationalObjectModuleNames.size()); i++ )
		{
			if( oldRelationalObjectModuleName == this->relationalObjectModuleNames[i] )
			{
				isMatch = true;
				relationTable.push_back( i );
				break;
			}
		}

		if( !isMatch )
		{
			// G[
			_ASSERT( false );
		}
	}

	return relationTable;
}

bool ObjectModule::Read( const std::string &filePath )
{
	// XMLƂēǂݍ
	bool isSuccessful = false;

	try{
#ifdef OBJECT_MODULE_IS_NOT_BINARY
		std::ifstream ifs( filePath.c_str() );
		boost::archive::xml_iarchive ia(ifs);
#else
		std::ifstream ifs( filePath.c_str(), std::ios::in | std::ios::binary );
		boost::archive::binary_iarchive ia(ifs);
#endif

		// t@CǍ
		ia >> boost::serialization::make_nvp( RootTagName(), *this );

		isSuccessful = true;
	}
	catch( boost::archive::archive_exception& e )
	{
		MessageBox( NULL, e.what(), "XMLVACY̗O", MB_OK );
	}
	catch(...){
		MessageBox( NULL, "archive_exceptionȊO̕sȗO", "XMLVACY̗O", MB_OK );
	}

	if( !isSuccessful )
	{
		return false;
	}

	return true;
}
bool ObjectModule::Write( const std::string &filePath ) const
{
	bool isSuccessful = false;

	try{
#ifdef OBJECT_MODULE_IS_NOT_BINARY
		std::ofstream ofs( filePath.c_str() );
		boost::archive::xml_oarchive oa(ofs);
#else
		std::ofstream ofs( filePath.c_str(), std::ios::out | std::ios::binary );
		boost::archive::binary_oarchive oa(ofs);
#endif

		// t@Cɏo
		oa << boost::serialization::make_nvp( RootTagName(), *this );

		isSuccessful = true;
	}
	catch( boost::archive::archive_exception& e )
	{
		MessageBox( NULL, e.what(), "XMLVACY̗O", MB_OK );
	}
	catch(...){
		MessageBox( NULL, "archive_exceptionȊO̕sȗO", "XMLVACY̗O", MB_OK );
	}

	if( !isSuccessful )
	{
		return false;
	}

	return true;
}
bool ObjectModule::ReadString( const std::string &str )
{
	bool isSuccessful = false;

	// ̓A[JCu̍쐬

	try{
#ifdef OBJECT_MODULE_IS_NOT_BINARY
		std::istringstream iss( str );
		boost::archive::xml_iarchive ia(iss);
#else
		std::istringstream iss( str, std::ios::in | std::ios::binary );
		boost::archive::binary_iarchive ia(iss);
#endif

		// Xg[Ǎ
		ia >> boost::serialization::make_nvp( RootTagName(), *this );

		isSuccessful = true;
	}
	catch( boost::archive::archive_exception& e )
	{
		MessageBox( NULL, e.what(), "XMLVACY̗O", MB_OK );
	}
	catch(...){
		MessageBox( NULL, "archive_exceptionȊO̕sȗO", "XMLVACY̗O", MB_OK );
	}

	if( !isSuccessful )
	{
		return false;
	}

	return true;
}
bool ObjectModule::WriteString( std::string &str ) const
{
	// o̓A[JCu̍쐬

	bool isSuccessful = false;
	try{
#ifdef OBJECT_MODULE_IS_NOT_BINARY
		std::ostringstream oss;
		boost::archive::xml_oarchive oa(oss);
#else
		std::ostringstream oss( "", std::ios::out | std::ios::binary );
		boost::archive::binary_oarchive oa(oss);
#endif

		// Xg[ɏo
		oa << boost::serialization::make_nvp( RootTagName(), *this );

		str = oss.str();

		isSuccessful = true;
	}
	catch( boost::archive::archive_exception &e )
	{
		MessageBox( NULL, e.what(), "XMLVACY̗O", MB_OK );
	}
	catch(...){
		MessageBox( NULL, "archive_exceptionȊO̕sȗO", "XMLVACY̗O", MB_OK );
	}

	return isSuccessful;
}
